1    REM December 23, 1980
2    REM BASIC-E
3    REM Modified for Osborne MBASIC by Jim Woolley, 6/82
4    REM This program will display a calendar for
5    REM any month from the year 15 A.D. to 20,000 A.D.
6    REM This program supports the original change as
7    REM announced by Pope Gregory in 1582 and the 
8    REM change adopted by the British in 1752.
9    REM Other cultures changed at different times and
10   REM some still have not changed.  No attempt is
11   REM made to support these.
12   REM
13   W0=52
14   E0$=CHR$(26): REM Character to erase screen
15   H0$=CHR$(27)+"=  ": REM Character to home cursor
16   U0$=CHR$(11)+SPACE$(W0)+CHR$(13)
17   WIDTH W0
18   REM
19   PRINT E0$;TAB((W0-49)/2);"CALENDAR FOR ANY MONTH FROM 15 A.D. TO 20000 A.D.":PRINT 
20   INPUT "Enter the number of the month";M
21   IF M<>INT(M) THEN PRINT U0$;: GOTO 20
22   O0=1: O1=0: O2=0
23   IF M<1 THEN PRINT U0$;: GOTO 20
25   IF M>12 THEN PRINT U0$;: GOTO 20
40   INPUT "Enter the year";Y: O=Y
41     IF Y<>INT(Y) THEN PRINT U0$;: GOTO 40
42   IF Y<15 THEN PRINT U0$;: GOTO 40
43   IF Y>20000 THEN PRINT U0$;: GOTO 40
44   IF Y*100+M<158210! THEN O0=0
45   IF Y*100+M<175210! AND Y*100+M>158209! THEN O1=1: GOTO 55
50   GOTO 60
55   INPUT "Do you want Julian/Anglican(=0) or Gregorian/Catholic(=1)";O0
56   IF O0<>0 AND O0<>1 THEN PRINT U0$;: GOTO 55
58   IF O0=0 AND Y*100+M=175209! THEN O2=11
59   IF O0=1 AND Y*100+M=158210! THEN O2=10: O0=0
60   PRINT E0$: X=INT(.6+1/M): Y1=Y-X: M1=M+12*X: X=Y1/100
70   N4=O0*INT(X/4): N3=O0*INT(X): N2=INT(5*Y1/4)
75   N1=INT(13*(M1+1)/5): N5=INT(Y1/4000)
80   X=N1+N2-N3+N4+5*(1-O0)-N5: A=X-7*INT(X/7)
81   REM A=0 FOR SUN. THRU 6 FOR SAT.
85   PRINT: PRINT: IF O2=10 THEN O0=1
86   IF O1=1 AND O0=0 THEN PRINT TAB((W0-16)/2);"JULIAN/ANGLICAN": PRINT
87   IF O1=1 AND O0=1 THEN PRINT TAB((W0-20)/2);"GREGORIAN/CATHOLIC": PRINT
88   IF O1=0 THEN PRINT: PRINT
90   IF M=1 THEN PRINT TAB((W0-32)/2);"J A N U A R Y";
100  IF M=2 THEN PRINT TAB((W0-34)/2);"F E B R U A R Y";
110  IF M=3 THEN PRINT TAB((W0-28)/2);"M A R C H";
120  IF M=4 THEN PRINT TAB((W0-28)/2);"A P R I L";
130  IF M=5 THEN PRINT TAB((W0-24)/2);"M A Y";
140  IF M=6 THEN PRINT TAB((W0-26)/2);"J U N E";
150  IF M=7 THEN PRINT TAB((W0-26)/2);"J U L Y";
160  IF M=8 THEN PRINT TAB((W0-30)/2);"A U G U S T";
170  IF M=9 THEN PRINT TAB((W0-36)/2);"S E P T E M B E R";
180  IF M=10 THEN PRINT TAB((W0-32)/2);"O C T O B E R";
190  IF M=11 THEN PRINT TAB((W0-34)/2);"N O V E M B E R";
195  IF M=12 THEN PRINT TAB((W0-34)/2);"D E C E M B E R";
200  D0=INT(Y/10000!): Y=Y-10000!*D0
201  D1=INT(Y/1000): Y=Y-1000*D1
202  D2=INT(Y/100): Y=Y-100*D2
203  D3=INT(Y/10)
204  D4=Y-10*D3
205  PRINT "     ";
206  IF O>9999 THEN PRINT D0; ELSE PRINT "  ";
207  IF O>999 THEN PRINT D1; ELSE PRINT "  ";
208  IF O>99 THEN PRINT D2; ELSE PRINT "  ";
209  PRINT D3;D4
210  PRINT TAB((W0-46)/2);"Sun    Mon    Tue    Wed    Thu    Fri    Sat"
220  PRINT 
230  L=31
240  IF M=4 THEN L=30
250  IF M=6 THEN L=30
260  IF M=9 THEN L=30
270  IF M=11 THEN L=30
275  O9=O/100
280  IF M=2 THEN L=28
281  IF M=2 AND O/4=INT(O/4) THEN L=29
285  IF M=2 AND O0=1 AND O9=INT(O9) AND O9/4<>INT(O9/4) THEN L=28
287  IF M=2 AND O/4000=INT(O/4000) THEN L=28
290  D=1: O0=10
300  FOR X=0 TO 6
310     PRINT TAB((W0-64+14*X+2*O0)/2);
320     IF A<=X THEN PRINT D;: D=D+1
325     IF O2=10 AND D=5 THEN D=D+10: O0=9
327     IF O2=11 AND D=3 THEN D=D+11: O0=9
330  NEXT : PRINT 
340  FOR X=0 TO 6
350     IF D>L THEN 370
360     PRINT TAB((W0-45+14*X-SGN(D-9.5))/2);D;: D=D+1
370  NEXT : PRINT 
371  IF D<=L THEN 340
380  PRINT H0$;: GOTO 20
390 END
 PRINT T