@center(@b[WHAT'S NEWS FROM PERFECT SOFTWARE])


@flushleft{@b(UPGRADES)}

	Our goal is to provide  'perfect' software--or as close
to that as we can get. In keeping with this philosophy we strive
to eradicate all software 'bugs' before the products are
released.  Given the sophistication of these programs, this is
sometimes hard to do. No matter how we much test a product, it is
often you, the end user, who finds the last of the bugs.  This is
not surprising, for just consider how many users there are and
how MUCH they are using the programs, putting them through trials
we can hardly dream of.   Thus, we rely on you the user for the
Ultimate Testing of the product.

	In the past months we have received numerous comments on
Perfect Software, some highly complementary, some highly
critical--many which identified problems.  We have been doing the
best we can to correct these.  Following are some of the problems
we have dealt with:
@begin(description)

@b[Perfect Writer's Delete Sentence Command (Escape. . .K)]@/ 
Early  versions of Perfect Writer had  problems with the Delete
to End of Sentence Command (ESC...K). (It sometimes couldn't find
the end of the sentence.) This bug is extinct as of Perfect
Writer version 1.033.  

@b(Perfect Calc 1.07:)  The Perfect Calc program supplied with
your KayPro (probably version 1.0) suffered two maladies.  First,
the 'swap' file was dynamic: it was created as needed (but was
limited in size to approximately 33K bytes).   Second, because
the Perfect Calc @b(Lesson) diskette and Perfect Calc @b(Program)
diskette were merged on one diskette, there was no disk space
left for the 'swap' file to grow.  Perfect Calc version 1.05 uses
a static 65K 'swap' file' which eliminates this problem.
@blankspace(1 lines)
	However,  before long users uncovered three more bugs in
Perfect Calc 1.05 (which we won't go into here).  Perfect Calc
version 1.07 is now in the final stages of in-house testing.  It
will shortly be released to selected users for further testing,
followed by a general release to all of you.

@b(Perfect Filer 1.2:) The Perfect Filer programs 'Create' and
'Move' at times created difficulties (too involved to describe
here).  In our new Filer upgrade 'Create' will provide now
provide a standard default list format as well as a specification
for standard labels for all data bases that you create
yourselves.
@end(description)

@b(What Version Do You Have?)

 Perfect Writer displays its version number on the screen while
you are in a file. It is that number following 'Writer' at the
bottom of the screen. Perfect Filer and Perfect Calc display
their version numbers on the screen after you type 'Filer' or
'pc', respectively, and before the screen displays the program.

@b(How Do You Obtain Upgrades?)

We are supplying upgrades to dealers and user groups as rapidly
as we can on a disk-for-a-disk basis.  If you and your KayPro are
huddled on island off the coast of Maine with no dealer or user
group for miles around, send $5 in check or money order (just
enough to cover our costs) per program update @b(OR) a blank
formatted diskette for each program update with stamped
self-addressed mailer to:
@display(Perfect Software  
Product Science Center 
P.O. Box 1479
Eugene, Oregon  97440) 

A full upgrade requires three diskettes.  Put your name, address
and what upgrades you desire on @u<each> diskette.  And please be
patient.  For speedier service see if your dealer or user group
already has these versions.
@newpage
@center{@b(NEWS STUFF)}

@subheading(Perfect Calc Lessons diskette)

	Many early Kaypro users never received the Perfect Calc
disk-based lessons which represent absolutely the best way to
learn about Perfect Calc.  We want to make these lessons
available to  as many people as want them.  If you don't have
them now, but want them, send $5 in check or money order (just
enough to cover our costs)
@b(OR) a blank formatted diskette with stamped self-addressed
mailer to:
@display(Perfect Software 
Product Science Center
P.O. Box 1479
Eugene, Oregon  97440)

	. . .and we'll send you back the lessons.  Please put
your name, address and what you desire on the diskette.  Check
with your dealer or user group first to see if they already have
this diskette.

@subheading(Tips diskette)  

	This diskette is an ongoing project to aid you in making
the most of your investment in the Kaypro II and Perfect
Software.  At present it consists of three main files, each with
a different emphasis.  'KAYPRO.MSS' is a short introductory
pamphlet that identifies the files of the Perfect Software
programs, indicating what they do and how to arrange them on your
diskettes.  It is a greatly enhanced version of the 4-page
pamphlet which you originally received with your Kaypro II.

  'KAYPRO2.LRN' is a much-enhanced edition of the file called
'KAYPRO.LRN' on your Perfect Writer Lessons diskette.  This
represents the least painful method of learning the CP/M
operating system we know of.  Third, 'BATCH.MSS' describes how to
format and print numerous files while maintaining consecutive
'counters' such as chapter, page, section, etc.  The Tips
diskette will not carry a version number but rather will be
identified by date in the diskette directory.  There will  be a
'-README' file to explain what files concern what subject.

	In distributing the 'TIPS Diskette' we will be 
attempting to reach as many end-users as we can @b(through)
dealers and user groups. That is, we'll send the diskette to
them, and they will (hopefully) make it available to clients and
members.  The National KUG Bulletin Board will soon have
information on this.  Unfortunately at Perfect Software we cannot
deal with individual end-users, since the volume would literally
overwhelm us.

@subheading(Perfect Speller Dictionaries)

A medical and a legal dictionary will soon be available for
Perfect Speller.  Our anticipated release date is May 1st. with a
planned price of $9.95 each.  Copies will be obtainable by mail
from:
@display(Perfect Software, Inc.
Perfect Speller Dictionaries
1400 Shattuck Avenue
Berkeley, CA   94709)

Please specify which dictionary you desire.
@newpage

@center(@b[FURTHER TIPS ON USING PERFECT SOFTWARE])


@SUBHEADING{@b(RUNNING OFF THE 'B' DRIVE)}

Diskette capacity of the KayPro II requires that all Perfect
Software program diskettes be placed in drive 'A' and all file
diskettes in drive 'B'.  Ordinarily this requires that a 'B:' be
placed in front of filenames when reading or writing a file to
disk.  If you forget to do this your data may be lost when
Perfect Writer, Perfect Speller or Perfect Calc attempts to write
to the full program diskette on drive 'A'.

	Here is an alternative that is nearly 'fail-safe'.  After
booting up your Kaypro in drive 'A', log immediately to drive
'B'.  The computer will automatically read and write files to
this drive.  From drive 'B' call up the program file on drive
'A'.  For example:
@center(@b[B> a:menu  <carriage return>])

	You are now logged to drive 'B', but operating with a
program in drive 'A'.   This eliminates the need for the disk drive
designation in front of filenames, thereby elimiating accidental
write operations to the 'A' drive.

	This will work with every Perfect Software program except
Perfect Filer  @b(Do not log onto drive 'b' when using Perfect
Filer.)  This program automatically transfers from drive to drive
as necessary.

	When running off drive 'B' be sure there are no Perfect
Writer command files on the diskette in drive 'b' that will
confuse Perfect Writer e.g. 'PF.DAT' or 'PW.SWP'.


@flushleft(@b{PW.HLP})

	In case you didn't know it, Perfect Writer provides an
on-line 'Help Menu' that will display all of the system commands. 
You can view this help menu by typing:

@center(@b[Escape. . .?]

or

@b[Control----X  ?])

The screen will be split horizontally and the HELP menu will
appear at the bottom of the screen.  Directions for selecting any
particular group of commands are given at the top of the
Directory.  To erase the HELP directory from the screen, type the
ONE WINDOW command: CTRL---X 1.

This helpful guide was added to Perfect Writer after the current
manual was printed.


@subheading{@b(FORMATTING TO CONSOLE)}

	In Perfect Writer what you see on the screen is not
always what you get out of the printer.  Some people find this to
be inconvenient, because they want to evaluate the layout of a
document  before it is printed to determine page breaks, the
appropriateness of format commands, etc.

	Perfect Writer will let you display a formatted document
to the screen before it is printed.  When formatting a document
simply select option 'C' of the  formatting menu--"Send the
output to the console device".

	Your document will be formatted according to the printer
definition 'console' and displayed to the screen.  The catch here
is that 'console' is a definition specifying 10-pitch,
non-proportional spaced printing, with one-inch margins on pages
of only 4 to 6 lines in length.  

	

	When displaying,  the file will scroll across the screen,
margins nicely justified, showing the true number of characters
per line you will obtain when printing the formatted file on
paper.  Special print commands such as underlining will not be
displayed.  Pages, however, will probably display in four to six
line page lengths.  By following a relatively simple procedure
you can obtain true page lengths. 

	@b(Start by making a back up copy of your Perfect Writer
Edit Diskette!) Then:
@begin(enumerate)

Place your Perfect Writer Edit diskette in
drive 'A' and your Installation diskette in drive 'B'.


 RESET the computer to initialize both diskettes.

 Type the following:@center(@b{b:pfconfig}  
<Followed by a RETURN>)  This will take you into the program
called 'PFCONFIG.COM' to alter the 'PF.DAT' file on your Perfect
Writer diskette.

The screen will fill with information and request a 'y' or 'n'. 
Supply it with an @center(@b{n})  This will fill the screen with
words that conclude with something along the lines of 'Type any character to
continue'. Enter your favorite letter.

  The screen will change to display text and a menu.  Type
@center(@b{2}   <Followed by a RETURN>)  You are now faced with
yet more text and another menu.  This is the one we've been
looking for.  Choose option 5 by typing:
@center(@b{5})  

We have reached our destination!  You should now be looking at a
three line display below the previous menu.  The first line tells
you what your 'current default printer' is.  The second line
indicates the 'current printer type for console output'.  Chances
are very good that the device name specified for console output
is 'Console'.  The third line asks 'What is the name of the
default printer type:'.  Enter the device name @u<exactly> as it
appears on the 'current default printer' line just above,
followed by a RETURN.

	  Now comes the $64,000 question: the screen will ask for
'the name of the printer type for console output:'. Enter the
name of your default printer device @u<exactly> as you did on the
line above, followed by a RETURN.  The screen will scroll and
redisplay the last menu you encountered.  

The last two steps to this updating process are easy. 
Type@center(@b{6}   <Followed by a RETURN>)  This returns you to
the first menu of 'PFCONFIG.  Then again type@center{@b(6)  
<Followed by a RETURN>}
@end(enumerate)

Congratulations!  You have completed the process and your file,
when 'Formatted to Console', will show true page lengths.

Using the 'Format to Console' option will scroll the file too
fast for you to be able to read it.  You can stop the scroll at
any time by typing@center(CTRL---S) and restart it by
@center(typing any character)  You can also incorporate Perfect
Formatter menu option 'A-Pause for manual insertion of each sheet
of paper' with 'Format to console' and not only will the file be
displayed with accurate page length but it will also
automatically stop the scroll at the bottom of each page so you
can see if you want to change where the pages breaks in the file.

This option will not create a printable '.FIN' file.  You must
put the '.mss' file through Perfect Formatter again using option
'G-Start the formatting now'.

@u(Before) you play with this, @u(please) make a back-up copy of
your Perfect Writer Edit diskette.



ter{@b(6)  
<Followed by a RETU