10 'BASECONV.BAS - Numeric conversion program written by R. S. Stein, W6NBI
20 '9-18-84
30 PRINT CHR$(26)
35 PRINT CHR$(27);CHR$(66);CHR$(48):PRINT CHR$(27);CHR$(66);CHR$(49)
40 PRINT " This program converts decimal numbers to equivalents in any base   "
50 PRINT " between 2 and 16, or converts numbers in base 2 to 16 to decimal   "
60 PRINT " equivalents.  It is limited to numbers between 0 and decimal 65535."
65 PRINT CHR$(27);CHR$(67);CHR$(48):PRINT CHR$(27);CHR$(67);CHR$(49)
70 PRINT 
80 INPUT "Enter base number (N) between 2 and 16 --> ",N%
90 IF N%<2 OR N%>16 THEN GOSUB 730 ELSE 110
100 GOTO 80
110 PRINT "Convert from:"
120 PRINT "   1 - Decimal to base N"
130 PRINT "   2 - Base N to decimal"
140 INPUT "Option 1 or 2? ",OPT
150 IF OPT<1 OR OPT>2 THEN GOSUB 730 ELSE 170
160 GOTO 140
170 PRINT 
180 ON OPT GOTO 190,410
190 'Decimal-to-base N conversion follows
200 INPUT "Decimal number = ";DEC
210 IF DEC<0 OR DEC>65535! OR DEC<>INT(DEC) THEN GOSUB 730 ELSE 230
220 GOTO 200
230 BAS$=""
240 D=DEC	'Save input number for output print string
250 FOR EX%=15 TO 0 STEP -1	'Start with left-most digit
260 B=INT(DEC/N%^EX%)
270 IF B=0 AND BAS$="" THEN 370  'Eliminate leading zeros
280 DECNEW=INT(DEC-B*(N%^EX%)+.5)
290 IF EX%=1 AND DECNEW=>N% THEN B=B+1 : GOTO 280  'Solve round-off error in last digit
300 DEC=DECNEW
310 RESTORE 800
320 IF B<10 THEN B$=STR$(B) : GOTO 360
330 FOR K%=10 TO B
340 READ B$
350 NEXT K%
360 BAS$=BAS$+B$	'Convert to string in base N
370 NEXT EX%
380 PRINT 
385 PRINT CHR$(27);CHR$(66);CHR$(48)
390 PRINT "DECIMAL ";D;" IS EQUIVALENT TO ";BAS$;CHR$(10);"Base";N%
395 PRINT CHR$(27);CHR$(67);CHR$(48)
400 GOTO 670
410 'Base N-to-decimal conversion follows
420 NUM$="" : DEC=0
430 INPUT "Enter number (using cap letters and no spaces) to be converted to decimal ",NUM$
440 L=LEN(NUM$)
450 FOR J%=1 TO L
460 IF L-J%+1=0 GOTO 660
470 M$=MID$(NUM$,(L-J%+1),1)
480 RESTORE 780
490 FOR K%=1 TO (N%-1)
500 READ MAX	'Highest value character allowed in base N
510 NEXT K%
520 RESTORE 780
530 IF ASC(M$)<48 OR ASC(M$)>MAX OR (ASC(M$)>57 AND ASC(M$)<65) THEN GOSUB 730 ELSE 550
540 GOTO 420
550 IF ASC(M$)<58 GOTO 600
560 RESTORE 820
570 FOR P%=65 TO ASC(M$)
580 READ M$
590 NEXT P%
600 M=VAL(M$)*N%^(J%-1)		'Convert each character to decimal number
610 DEC=DEC+M	'Sum decimal numbers
620 NEXT J%
630 IF INT(DEC+.5)>65535! THEN GOSUB 730 ELSE 650
640 GOTO 420
650 PRINT 
655 PRINT CHR$(27);CHR$(66);CHR$(48)
660 PRINT "DECIMAL EQUIVALENT OF  ";NUM$;" [Base";STR$(N%);"]  IS ";INT(DEC+.5)
665 PRINT CHR$(27);CHR$(67);CHR$(48)
670 PRINT 
680 INPUT "Run again? (Y/N)",R$
690 IF R$<>"Y" AND R$<>"y" THEN END
700 DEC=0
710 PRINT CHR$(26)
720 GOTO 80
730 'Error message
740 PRINT "   YOU HAVE ENTERED AN INVALID NUMBER!"
750 PRINT 
760 RETURN
770 'ASCII code for highest value character allowed in selected base
780 DATA 49,50,51,52,53,54,55,56,57,65,66,67,68,69,70
790 'String values for decimal 10 to 15
800 DATA " A"," B"," C"," D"," E"," F"
810 'Decimal values for A thru F in base N
820 DATA "10","11","12","13","14","15"
1000 '-------------------------------------------------------------------------
1010 '
1020 'BASE   EQUIVALENCE OF DECIMAL 65535
1030 '
1040 '  2	1111111111111111
1050 '  3	     10022220020
1060 '  4	        33333333
1070 '  5	         4044120
1080 '  6	         1223223
1090 '  7	          362031
1100 '  8	          177777
1110 '  9		  108806
1120 ' 10		   65535
1130 ' 11		   45268
1140 ' 12 		   31B13
1150 ' 13		   23AA2
1160 ' 14		   19C51
1170 ' 15		   14640
1180 ' 16		    FFFF
1130 ' 11		   45268
1140 ' 12 		   31B13
1150 ' 13		   23AA2
1160 '