10 'T.R. APEL 27 DEC 1981 - REV. 27 JUNE 1983
20 DIM G(25),C(25),PD(25),S(25),TR(25)
25 PRINT CHR$(26)
30 PRINT STRING$(28,42);" BROADBAND MATCHING ";STRING$(28,42) : PRINT
33 INPUT "PRINT TO SCREEN (S) OR PRINTER (P)";PRN$
35 IF PRN$="S" THEN POKE 3,65
38 IF PRN$="P" THEN POKE 3,129
50 PRINT : JJ=0
51 PRINT"PROGRAM MATCHES TWO SPECIFIED LOADS, WHERE ONE LOAD MAY HAVE A"
52 PRINT"REACTIVE COMPONENT, AS FOLLOWS." : PRINT 
53 PRINT"   LOW-IMPEDANCE LOAD:"
54 PRINT"      SL - SERIES INDUCTANCE"
55 PRINT"      SC - SERIES CAPACITANCE"
56 PRINT"   HIGH-IMPEDANCE LOAD:"
58 PRINT"      PL - PARALLEL (SHUNT) INDUCTANCE"
60 PRINT"      PC - PARALLEL (SHUNT) CAPACITANCE"
61 PRINT 
65 INPUT "TYPE OF LOAD [SL,SC,PL OR PC]";T$
70 ON ERROR GOTO 870 : PRINT
80 INPUT "3-dB BAND-EDGE FREQUENCIES [F1,F2 IN MHz]";F1,F2
90 BW=ABS(F2-F1)
100 F0=SQR(F2*F1)
110 QT=F0/BW : W0=F0*.001
120 PRINT
125 PRINT"DO YOU WANT THE REACTIVE COMPONENT OF THE COMPLEX LOAD INCORPORATED"
126 INPUT"AS THE ADJACENT ELEMENT OF THE MATCHING NETWORK (Y/N)";A$
140 IF A$="N" THEN LV=0 : GOTO 170
150 IF T$="SL" OR T$="PL" THEN PRINT : INPUT "VALUE OF LOAD L [nH]";LV
160 IF T$="SC" OR T$="PC" THEN PRINT : INPUT "VALUE OF LOAD C [pF]";LV
170 PRINT : INPUT "HIGH IMPEDANCE PORT";HZ
180 INPUT "LOW IMPEDANCE PORT";LZ
190 TD=HZ/LZ : PI=3.14159
200 IF LV<=.001 THEN QL=.5 : GOTO 260
210 IF T$="SL" THEN QL=LV*2*PI*W0/LZ : GOTO 260
220 IF T$="SC" THEN QL=1/(LV*2*PI*W0*.001*LZ) : GOTO 260
230 IF T$="PL" THEN QL=HZ/(LV*2*PI*W0) : GOTO 260
240 IF T$="PC" THEN QL=LV*2*PI*W0*.001*HZ : GOTO 260
250 GOTO 50
260 IF QL/QT<=.25 THEN LV=0
270 PRINT
280 INPUT "NUMBER OF NETWORK ELEMENTS [MULTIPLE OF 4]";N
290 N=N/2
300 G1=QL/QT
310 PRINT : LPRINT "QT = ";(.0001*INT(10000!*QT))
320 GOTO 700
330 X=(1/GN1+1/G1)*SIN(PI/(2*N))
340 Y=(1/GN1-1/G1)*SIN(PI/(2*N))
350 IF LV<=.001 THEN X=(2/GN1)*SIN(PI/(2*N)) : Y=0 : G1=GN1
360 FOR J=2 TO N
370 I=J-1
380 P1=4*SIN((2*I-1)*PI/(2*N))*SIN((2*I+1)*PI/(2*N))
390 Q1=X*X+Y*Y+SIN(I*PI/N)^2-2*X*Y*COS(I*PI/N)
400 G(J)=P1/Q1
410 NEXT J
420 G(0)=1#
430 G(1)=G1
440 FOR H=2 TO N
450 IF H>2 GOTO 470
460 GH1=G1
470 G(H)=G(H)/GH1
480 GH1=G(H)
490 NEXT H
500 G(N+1)=GN1/GH1
510 FOR I=0 TO N+1 : IF G(I)<.001 THEN JJ=1
520 NEXT I
530 PRINT : PRINT "CALCULATING"
540 IF T$>"S" THEN GOSUB 1530
550 RETURN
560 DEF FNI(Z)=LOG(Z+SQR(Z*Z+1))
570 DEF FNS(Z)=(EXP(Z)-EXP(-Z))/2
580 DEF FNC(Z)=(EXP(Z)+EXP(-Z))/2
590 A=FNI(X) : B=FNI(Y)
600 NA=N*A : NB=N*B
610 R1=ABS(FNC(NB)/FNC(NA))
620 R2=ABS(FNS(NB)/FNS(NA))
630 L1=-.0001*INT(100000!*LOG(1-R1*R1)/LOG(10))
640 L2=-.0001*INT(100000!*LOG(1-R2*R2)/LOG(10))
650 V1=.001*INT(1000!*(1+R1)/(1-R1))
660 V2=.001*INT(1000!*(1+R2)/(1-R2))
670 PRINT : LPRINT "MAX LOSS [dB] = ";L1;TAB(27);"VSWR = ";V1
680 LPRINT "MIN LOSS [dB] = ";L2;TAB(27);"VSWR = ";V2
690 RETURN
700 X1=2*QL/QT
710 K=0
720 GN1=X1
730 GOSUB 890
740 D1=NT
750 X2=ABS(X1*1.0001)
760 GN1=X2
770 GOSUB 890
780 D2=NT
790 K=K+1
800 IF ABS(ER/TD)<.000001 THEN 1030
810 IF D1=D2 OR K>50 OR JJ=1 THEN 850
820 GN1=X1+ER*X1*.0001/(D2-D1)
830 X1=GN1
840 GOTO 730
850 LPRINT "RL:RS RATIO IS TOO SMALL OR RIPPLE IS TOO SMALL FOR AVAILABLE PRECISION -"
860 LPRINT "   INCREASE BW OR CHANGE TR SPECIFICATION" : GOTO 880
870 LPRINT "NETWORK ORDER IS TOO LARGE OR TOO SMALL"
880 FOR II=1 TO 1500 : NEXT II : GOTO 25
890 GOSUB 330
900 G(2*N+1)=G(N+1)
910 FOR J=1 TO N
920 G(J+N)=1/(QT*QT*G(J))
930 NEXT J
940 TT=1
950 FOR J=1 TO 10 : TR(J)=1 : NEXT J
960 FOR J=2 TO N STEP 2
970 TR(J/2)=1+QT*QT*G(J)*G(J-1)
980 TT=TT*(TR(J/2)*TR(J/2))
990 NEXT J
1000 NT=TT*G(2*N+1)
1010 ER=TD-NT
1020 RETURN
1030 LPRINT : IF LV=<.001 THEN LPRINT "0 dB OFFSET CASE"
1040 LPRINT "SOURCE Q = ";.0001*INT(10000!*GN1*QT)
1050 LPRINT "LOAD   Q = ";.0001*INT(10000!*G1*QT) : GOSUB 560
1060 O=.0001*INT(10000!*NT)
1070 LPRINT : LPRINT "IMPEDANCE TRANSFORMATION RATIO = ";O
1080 FOR J=2 TO N STEP 2
1090 H=G(J+N)
1100 G(J+N)=G(J)
1110 G(J)=H
1120 NEXT J
1130 TT=1
1140 FOR J=2 TO N STEP 2
1150 V1=G(J)
1160 G(J-1)=G(J-1)+(1-TR(J/2))*V1
1170 G(J)=TR(J/2)*V1
1180 C(J)=TR(J/2)*(TR(J/2)-1)*V1
1190 FOR J1=J TO N STEP 2
1200 G(J1+N)=G(J1+N)/TR(J/2)/TR(J/2)
1210 IF J1=J THEN 1250
1220 G(J1+N-1)=G(J1+N-1)/TR(J/2)/TR(J/2)
1230 G(J1)=G(J1)*TR(J/2)*TR(J/2)
1240 G(J1-1)=G(J1-1)*TR(J/2)*TR(J/2)
1250 NEXT J1
1260 G(2*N+1)=TR(J/2)*TR(J/2)*G(2*N+1)
1270 NEXT J
1275 PRINT
1280 INPUT "PRESS <CR> TO CONTINUE",N$
1290 LPRINT : LPRINT "BANDPASS MATCHING NETWORK"
1300 LPRINT "-------------------------"
1310 BW=2*PI*BW*1E+06
1320 FOR J=2 TO N STEP 2
1330 PD(J-1)=G(J-1)/BW/HZ
1340 PD(J)=G(J)/BW/HZ
1350 C(J)=C(J)/BW/HZ
1360 PD(J+N)=G(J+N)*HZ/BW
1370 PD(J+N-1)=G(J+N-1)*HZ/BW
1380 NEXT J
1390 PD(0)=G(0)*HZ
1400 PD(2*N+1)=HZ/G(2*N+1)
1410 GOSUB 1570
1420 LPRINT RR$;S(0);TAB(15);R$
1430 FOR J=2 TO N STEP 2
1440 LPRINT P1$;S(J+N-1);TAB(15);L$
1450 LPRINT S1$;S(J-1);TAB(15);C$
1460 LPRINT P2$;S(J);TAB(15);C$
1470 LPRINT S2$;S(J+N);TAB(15);L$
1480 NEXT J
1490 LPRINT RR$;S(2*N+1);TAB(15);R$
1500 INPUT "ANOTHER CALCULATION (Y/N)";B$
1510 IF B$<>"Y" AND B$<>"y" THEN POKE 3,129 : END
1520 PRINT : GOTO 25
1530 FOR H=0 TO N+1 : T(H)=G(N-H+1) : NEXT H
1540 FOR H=1 TO N-1 STEP 2 : G(H)=T(H)*T(0) : G(H+1)=T(H+1)/T(0) : NEXT H
1550 G(0)=1 : G(N+1)=T(0)
1560 RETURN
1570 REM
1580 S(0)=PD(0)
1590 FOR J=2 TO N STEP 2
1600 S(J+N-1)=PD(J+N-1)
1610 S(J-1)=PD(J)
1620 S(J)=C(J)
1630 S(J+N)=PD(J+N)
1640 NEXT J
1650 S(2*N+1)=PD(2*N+1)
1660 IF T$="SL" OR T$="PL" GOTO 1770
1670 WC=1/(2*PI*F0*1E+06)^2
1680 FOR J=2 TO N STEP 2
1690 S(J+N-1)=1E+12*WC/S(J+N-1)
1700 S(J-1)=1E+09*WC/S(J-1)
1710 S(J)=1E+09*WC/S(J)
1720 S(J+N)=1E+12*WC/S(J+N)
1730 NEXT J
1740 RR$="R  =" : P1$="CP =" : S1$="LS =" : P2$="LP =" : S2$="CS ="
1750 R$=" ohms" : C$=" nH" : L$=" pF"
1760 GOTO 1850
1770 FOR J=2 TO N STEP 2
1780 S(J+N-1)=1E+09*S(J+N-1)
1790 S(J-1)=1E+12*S(J-1)
1800 S(J)=1E+12*S(J)
1810 S(J+N)=1E+09*S(J+N)
1820 NEXT J
1830 RR$="R  =" : P1$="LP =" : S1$="CS =" : P2$="CP =" : S2$="LS ="
1840 R$=" ohms" : L$=" nH" : C$=" pF"
1850 FOR J=0 TO 2*N+1 : S(J)=.001*INT(1000!*S(J)) : NEXT J
1860 RETURN
20 PRINT : GOTO 25
1530 FOR H=0 TO N+1 : T(H)=G(N-H+1) : NEXT H
