10 'NETWORKS - Written by R. S. Stein, W6NBI - 6/30/84
15 'Error traps added 12/20/84
20 PRINT CHR$(26)
30 PRINT "NETWORKS computes reactance values for seven high-pass and seven"
40 PRINT "low-pass configurations of 2- and 3-element matching networks."
50 PRINT "If load at either end of network includes a reactive component,"
60 PRINT "the reactance will be absorbed by the network if possible."
65 FLAG%=0
70 PRINT : PRINT "SELECT THE BASIC NETWORK FROM THE FOLLOWING LIST:"
80 PRINT "   (1) STANDARD L-NETWORK"
90 PRINT "   (2) STANDARD PI-NETWORK"
100 PRINT "   (3) MIXED PI-NETWORK"
110 PRINT "   (4) STANDARD T-NETWORK"
120 PRINT "   (5) MIXED T-NETWORK"
130 PRINT "   (6) SERIES ENHANCED-Q L-NETWORK"
140 PRINT "   (7) SHUNT ENHANCED-Q L-NETWORK"
150 PRINT "   (0) ALL OF THE ABOVE"
160 INPUT "YOUR CHOICE";B
170 IF B=>0 AND B=<7 GOTO 190 ELSE PRINT "-->INCORRECT INPUT!"
180 GOTO 70
190 PRINT 
195 IF FLAG%=1 GOTO 260
200 INPUT "CENTER FREQUENCY (MHz)";F
210 PRINT 
220 PI=3.14159
230 PRINT "FOR THE LOAD HAVING THE >> SMALLER << RESISTIVE VALUE,"
240 GOSUB 2260
250 RS=LR : S$=T$
260 IF T$="S" THEN XSS=LX
270 IF T$="P" THEN XSP=LX
280 IF T$="S" AND B=0 THEN TS$="S"
290 IF T$="S" AND (B=2 OR B=3) GOTO 440
300 IF T$="P" AND B=0 THEN TS$="P"
310 IF T$="P" AND (B=1 OR B=>4) GOTO 440
315 IF FLAG%=1 GOTO 360
320 PRINT 
330 PRINT "FOR THE LOAD HAVING THE >> LARGER << RESISTIVE VALUE,"
340 GOSUB 2260
350 RL=LR : L$=T$
360 IF T$="S" THEN XLS=LX
370 IF T$="P" THEN XLP=LX
380 IF T$="P" AND B=0 THEN TL$="P"
390 IF T$="P" AND (B=4 OR B=5)  GOTO 440
400 IF T$="S" AND B=0 THEN TL$="S"
410 IF T$="S" AND (B=1 OR B=2 OR B=3 OR B=>6) GOTO 440
420 GOTO 460
430 PRINT 
440 PRINT : PRINT "REACTIVE COMPONENT CANNOT BE ABSORBED BY SELECTED NETWORK - CHOOSE ANOTHER"
450 FLAG%=1 : GOTO 70
460 IF RS=>RL GOTO 220
470 PRINT 
480 INPUT "HIGH- OR LOW-PASS NETWORK CONFIGURATION (H OR L)";C$
490 IF C$<>"H" AND C$<>"L" THEN PRINT "-->INCORRECT ENTRY!" : GOTO 470
500 IF C$="H" THEN N$=" (HIGH PASS)" ELSE N$=" (LOW PASS)"
510 QM=SQR(RL/RS-1)
520 PRINT
530 PRINT USING "MINIMUM Q =##.#";QM+.001   'Adding .001 prevents divide-by-zero error
540 INPUT "DESIRED Q";Q
550 IF Q=<QM GOTO 520
560 DEF FNL(X)=X/(2*PI*F*1E+06)
570 DEF FNC(X)=ABS(1/(2*PI*F*1E+06*X))
580 A=Q^2+1
590 PRINT : PRINT "IN EACH NETWORK, ELEMENTS ARE LISTED IN ORDER FROM SMALLER TO LARGER LOAD,"
600 PRINT "AND ARE DEFINED AS FOLLOWS:"
610 PRINT "   RS = SMALLER LOAD RESISTANCE"
620 PRINT "   CS = SERIES CAPACITANCE"
630 PRINT "   CP = PARALLEL (SHUNT) CAPACITANCE"
640 PRINT "   LS = SERIES INDUCTANCE"
650 PRINT "   LP = PARALLEL (SHUNT) INDUCTANCE"
660 PRINT "   RL = LARGER LOAD RESISTANCE"
670 IF B=0 THEN GOSUB 850 ELSE GOTO 820
680 PRINT : INPUT "Hit <CR> to continue",A$
690 GOSUB 1030
700 PRINT : INPUT "Hit <CR> to continue",A$
710 GOSUB 1200
720 PRINT : INPUT "Hit <CR> to continue",A$
730 GOSUB 1370
740 PRINT : INPUT "Hit <CR> to continue",A$
750 GOSUB 1540
760 PRINT : INPUT "Hit <CR> to continue",A$
770 GOSUB 1710
780 PRINT : INPUT "Hit <CR> to continue",A$
790 GOSUB 1880
800 PRINT 
810 GOTO 830
820 ON B GOSUB 850,1030,1200,1370,1540,1710,1880
830 PRINT : INPUT "RUN AGAIN (Y/N)";R$
840 IF R$="Y" OR R$="y" THEN PRINT CHR$(26) : GOTO 65 ELSE END
850 P$="STANDARD L-NETWORK"
860 IF TS$="P" OR TL$="S" THEN GOSUB 2570 ELSE GOTO 880
870 GOTO 1010
880 X1=SQR(RS*RL-RS^2)
890 X2=-RS*RL/X1
900 IF C$="H" THEN X1=-X1:X2=-X2
910 IF S$<>"N" THEN X1=X1-XSS 
920 IF L$<>"N" THEN X2=XLP*X2/(XLP-X2)
930 IF X1<0 THEN CS1=FNC(X1) ELSE LS1=FNL(X1)
940 IF X2<0 THEN CP2=FNC(X2) ELSE LP2=FNL(X2)
950 PRINT : PRINT P$+N$
960 PRINT "   F  =";F;"MHz"
970 PRINT "   Q  =";QM;"(always equals minimum Q for standard L-networks)"
980 GOSUB 2080
990 PRINT "   RL =";RL;"ohms"
1000 CS1=0:LS1=0:CP2=0:LP2=0
1010 RETURN
1020 '-------------------------------------------------------------------------
1030 P$="STANDARD PI-NETWORK"
1040 IF TS$="S" OR TL$="S" THEN GOSUB 2570 ELSE GOTO 1060
1050 GOTO 1180
1060 X1=-RS*SQR((RL/RS)/(A-(RL/RS)))
1070 X2=(Q*RL-RS*RL/X1)/A
1080 X3=-RL/Q
1090 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1100 IF S$<>"N" THEN X1=XSP*X1/(XSP-X1) 
1110 IF L$<>"N" THEN X3=XLP*X3/(XLP-X3) 
1120 IF X1<0 THEN CP1=FNC(X1) ELSE LP1=FNL(X1)
1130 IF X2<0 THEN CS2=FNC(X2) ELSE LS2=FNL(X2)
1140 IF X3<0 THEN CP3=FNC(X3) ELSE LP3=FNL(X3)
1150 GOSUB 2050
1160 GOSUB 2190
1170 CP1=0:LP1=0:CS2=0:LS2=0:CP3=0:LP3=0
1180 RETURN
1190 '------------------------------------------------------------------------
1200 P$="MIXED PI-NETWORK"
1210 IF TS$="S" OR TL$="S" THEN GOSUB 2570 ELSE GOTO 1230
1220 GOTO 1350
1230 X1=RS/SQR(RS*A/RL-1)
1240 X2=(RL*Q/A)*(1-(RS/(Q*X1)))
1250 X3=-RL/Q
1260 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1270 IF S$<>"N" THEN X1=XSP*X1/(XSP-X1) 
1280 IF L$<>"N" THEN X3=XLP*X3/(XLP-X3)
1290 IF X1<0 THEN CP1=FNC(X1) ELSE LP1=FNL(X1)
1300 IF X2<0 THEN CS2=FNC(X2) ELSE LS2=FNL(X2)
1310 IF X3<0 THEN CP3=FNC(X3) ELSE LP3=FNL(X3)
1320 GOSUB 2050
1330 GOSUB 2190
1340 CP1=0:LP1=0:CS2=0:LS2=0:CP3=0:LP3=0
1350 RETURN
1360 '------------------------------------------------------------------------
1370 P$="STANDARD T-NETWORK"
1380 IF TS$="P" OR TL$="P" THEN GOSUB 2570 ELSE GOTO 1400
1390 GOTO 1520
1400 X1=RS*Q
1410 X2=-RS*A/(Q+SQR(RS*A/RL-1))
1420 X3=RL*SQR(RS*A/RL-1)
1430 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1440 IF S$<>"N" THEN X1=X1-XSS
1450 IF L$<>"N" THEN X3=X3-XLS
1460 IF X1<0 THEN CS1=FNC(X1) ELSE LS1=FNL(X1)
1470 IF X2<0 THEN CP2=FNC(X2) ELSE LP2=FNL(X2)
1480 IF X3<0 THEN CS3=FNC(X3) ELSE LS3=FNL(X3)
1490 GOSUB 2050
1500 GOSUB 2190
1510 CS1=0:LS1=0:CP2=0:LP2=0:CS3=0:LS3=0
1520 RETURN
1530 '------------------------------------------------------------------------
1540 P$="MIXED T-NETWORK"
1550 IF TS$="P" OR TL$="P" THEN GOSUB 2570 ELSE GOTO 1570
1560 GOTO 1690
1570 X1=RS*Q
1580 X2=-RS*A/(Q-SQR(RS*A/RL-1))
1590 X3=-RL*SQR(RS*A/RL-1)
1600 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1610 IF S$<>"N" THEN X1=X1-XSS 
1620 IF L$<>"N" THEN X3=X3-XLS
1630 IF X1<0 THEN CS1=FNC(X1) ELSE LS1=FNL(X1)
1640 IF X2<0 THEN CP2=FNC(X2) ELSE LP2=FNL(X2)
1650 IF X3<0 THEN CS3=FNC(X3) ELSE LS3=FNL(X3)
1660 GOSUB 2050
1670 GOSUB 2190
1680 CS1=0:LS1=0:CP2=0:LP2=0:CS3=0:LS3=0
1690 RETURN
1700 '------------------------------------------------------------------------
1710 P$="SERIES ENHANCED-Q L-NETWORK"
1720 IF TS$="P" OR TL$="S" THEN GOSUB 2570 ELSE GOTO 1740
1730 GOTO 1860
1740 X1=-Q*RS
1750 X3=-RL*SQR(RS/(RL-RS))
1760 X2=-(X1+RS*RL/X3)
1770 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1780 IF S$<>"N" THEN X2=X2-XSS
1790 IF L$<>"N" THEN X3=XLP*X3/(XLP-X3)
1800 IF X1<0 THEN CS1=FNC(X1) ELSE LS1=FNL(X1)
1810 IF X2<0 THEN CS2=FNC(X2) ELSE LS2=FNL(X2)
1820 IF X3<0 THEN CP3=FNC(X3) ELSE LP3=FNL(X3)
1830 GOSUB 2050
1840 GOSUB 2190
1850 CS1=0:LS1=0:CS2=0:LS2=0:CP3=0:LP3=0
1860 RETURN
1870 '------------------------------------------------------------------------
1880 P$="SHUNT ENHANCED-Q L-NETWORK"
1890 IF TS$="P" OR TL$="S" THEN GOSUB 2570 ELSE GOTO 1910
1900 GOTO 2030
1910 X1=RS*SQR(RL/RS-1)
1920 X2=-RL/Q
1930 X3=X2/(X1/(Q*RS)-1)
1940 IF C$="H" THEN X1=-X1:X2=-X2:X3=-X3
1950 IF S$<>"N" THEN X1=X1-XSS
1960 IF L$<>"N" THEN X3=XLP*X3/(XLP-X3)
1970 IF X1<0 THEN CS1=FNC(X1) ELSE LS1=FNL(X1)
1980 IF X2<0 THEN CP2=FNC(X2) ELSE LP2=FNL(X2)
1990 IF X3<0 THEN CP3=FNC(X3) ELSE LP3=FNL(X3)
2000 GOSUB 2050
2010 GOSUB 2190
2020 CS1=0:LS1=0:CP2=0:LP2=0:CP3=0:LP3=0
2030 RETURN
2040 '------------------------------------------------------------------------
2050 PRINT : PRINT P$+N$
2060 PRINT "   F  =";F;"MHz"
2070 PRINT "   Q  =";Q
2080 PRINT "   RS =";RS;"ohms"
2090 IF CS1>0 THEN PRINT "   CS =";CS1*1E+12;"pF"
2100 IF LS1>0 THEN PRINT "   LS =";LS1*1E+09;"nH"
2110 IF CP1>0 THEN PRINT "   CP =";CP1*1E+12;"pF"
2120 IF LP1>0 THEN PRINT "   LP =";LP1*1E+09;"nH"
2130 IF CS2>0 THEN PRINT "   CS =";CS2*1E+12;"pF"
2140 IF LS2>0 THEN PRINT "   LS =";LS2*1E+09;"nH"
2150 IF CP2>0 THEN PRINT "   CP =";CP2*1E+12;"pF"
2160 IF LP2>0 THEN PRINT "   LP =";LP2*1E+09;"nH"
2170 RETURN
2180 '------------------------------------------------------------------------
2190 IF CS3>0 THEN PRINT "   CS =";CS3*1E+12;"pF"
2200 IF LS3>0 THEN PRINT "   LS =";LS3*1E+09;"nH"
2210 IF CP3>0 THEN PRINT "   CP =";CP3*1E+12;"pF"
2220 IF LP3>0 THEN PRINT "   LP =";LP3*1E+09;"nH"
2230 PRINT "   RL =";RL;"ohms"
2240 RETURN
2250 '------------------------------------------------------------------------
2260 PRINT "USE ONE OF THE FOLLOWING ABBREVIATIONS FOR THE TYPE OF LOAD:"
2270 PRINT "   N  - NO REACTANCE"
2280 PRINT "   SC - SERIES CAPACITIVE REACTANCE"
2290 PRINT "   SL - SERIES INDUCTIVE REACTANCE"
2300 PRINT "   PC - PARALLEL (SHUNT) CAPACITIVE REACTANCE"
2310 PRINT "   PL - PARALLEL (SHUNT) INDUCTIVE REACTANCE"
2320 INPUT "TYPE OF LOAD";T$
2330 IF T$="SC" OR T$="SL" OR T$="PC" OR T$="PL" OR T$="N" GOTO 2360 
2340 PRINT "-->INCORRECT ENTRY!"
2350 PRINT : GOTO 2260
2360 PRINT 
2380 INPUT "LOAD RESISTANCE";LR
2390 IF T$="N" GOTO 2550
2392 PRINT 
2393 IF T$<>"N" THEN PRINT "DO YOU WANT TO ENTER REACTANCE (X) IN OHMS OR COMPONENT VALUE (V) IN nH OR pF?"
2396 IF T$<>"N" THEN INPUT "(X or V)";D$
2400 IF D$="X" THEN PRINT ELSE GOTO 2460
2410 IF T$="SC" OR T$="PC" THEN PRINT "USE NEGATIVE VALUE FOR CAPACITIVE REACTANCE"
2420 INPUT "LOAD REACTANCE";LX
2430 IF LX=>0 AND (T$="SC" OR T$="PC") THEN PRINT "-->INCORRECT ENTRY!" : PRINT : GOTO 2410
2440 IF LX=<0 AND (T$="SL" OR T$="PL") THEN PRINT "-->INCORRECT ENTRY!" : PRINT : GOTO 2420
2450 GOTO 2530
2460 IF T$="SC" OR T$="PC" THEN INPUT "LOAD CAPACITANCE (pF)";C ELSE GOTO 2500
2470 IF C=<0 THEN PRINT "-->INCORRECT ENTRY!" : PRINT : GOTO 2460
2480 LX=1/(2*PI*F*C*.000001)
2490 GOTO 2530
2500 IF T$="SL" OR T$="PL" THEN INPUT "LOAD INDUCTANCE (nH)";L
2510 IF L=<0 THEN PRINT "-->INCORRECT ENTRY!" : PRINT : GOTO 2500
2520 LX=2*PI*F*L*.001
2530 IF T$="SC" OR T$="SL" THEN T$="S"
2540 IF T$="PC" OR T$="PL" THEN T$="P"
2550 RETURN
2560 '------------------------------------------------------------------------
2570 PRINT : PRINT "REACTIVE COMPONENT CANNOT BE ABSORBED BY ";P$
2580 PRINT 
2590 RETURN
2600 '========================================================================
2610 'Glossary of variables
2620 '   Source = load with lower resistance
2630 '   Load   = load with higher resistance
2640 '
2650 'A		Defines Q^2+1
2660 'B		Type of network 
2670 'C		Source or load capacitance entered
2680 'C$	Network configuration (hi- or lo-pass)	
2690 'CPn	Parallel (shunt) capacitance
2700 'CSn	Series capacitance
2710 'D$	Reactance or component value entered
2720 'F		Frequency
2730 'FNC(x)    Converts reactance to capacitance
2740 'FNL(x)    Converts reactance to inductance
2750 'L		Source or load inductance entered
2760 'L$	Flag for reactive load
2770 'LPn	Parallel (shunt) inductance
2780 'LR	Source or load resistance entered
2790 'LSn	Series inductance
2800 'LX	Source or load reactance entered or calculated
2810 'N$	Network configuration name for printout
2820 'P$	Network name for printout
2830 'QM	Min. Q
2840 'RL	Load resistance
2850 'RS	Source resistance
2860 'S$	Flag for reactive source
2870 'T$	Type of source or load impedance entered
2880 'TL$	Type of load impedance
2890 'TS$	Type of source impedance
2900 'X		Source or load reactance entered
2910 'Xn	Network element reactance
2920 'XLP	Load parallel (shunt) reactance
2930 'XLS	Load series reactance
2940 'XSP	Source parallel (shunt) reactance
2950 'XSS	Source series reactance
t) rea