10 PRINT CHR$(26)
20 'TWINTOSC.BAS
30 'Formula derived and program written by Bob Stein, W6NBI - 8/15/86
40 PRINT TAB(48);"o-------o---/\/\---o Vcc
50 PRINT "THIS PROGRAM DESIGNS A TWIN-T";TAB(48);"|       |   3300
60 PRINT "AUDIO-FREQUENCY OSCILLATOR,";TAB(46);"|/        |
70 PRINT "USING AN EMPIRICALLY DERIVED";TAB(40);"o-----|         |
80 PRINT "FORMULA.";TAB(40);"|     |\        |
90 PRINT TAB(40);"|       |       |
100 PRINT TAB(40);"|      ---      |
110 PRINT TAB(40);"|      ///      |    C3
120 PRINT TAB(40);"|       o-------|----||----> Hi-Z
130 PRINT TAB(40);"|       |       |            OUTPUT
140 PRINT TAB(40);"o--\/\--o--/\/--o
150 PRINT TAB(40);"|  R2   |   R2  |
160 PRINT TAB(40);"|      ---      |
170 PRINT TAB(40);"|   C2 ---      |
180 PRINT TAB(40);"|       |       |
190 PRINT TAB(40);"|       o---o   |
200 PRINT TAB(40);"|       |   |   |
210 PRINT TAB(40);"|       /  ---  |
220 PRINT TAB(40);"|    R1 \  ///  |
230 PRINT TAB(40);"|       /       |
240 PRINT TAB(40);"|   C1  |  C1   |
250 PRINT TAB(40);"o---||--o--||---o
260 PRINT CHR$(27)+"="+CHR$(39)+CHR$(32)
270 INPUT "ENTER FREQUENCY IN Hz: ",F
280 PRINT 
290 PRINT "ENTER STARTING VALUE OF
300 INPUT "C1 IN uF (.01 is optimum): ",C1
310 C1=C1*.000001
320 C2=2*C1
330 R2=(.382/F)*SQR(1/(C1*C2))
340 R1=R2/10
350 C3=1/(2*3.14159*330*F)
360 PRINT : PRINT 
370 PRINT "C1 =";C1*1E+06;"uF"
380 PRINT "C2 =";C2*1E+06;"uF"
390 PRINT "C3 =";C3*1E+06;"uF (minimum)"
400 PRINT "R1 =";INT(R1);"OHMS"
410 PRINT "R2 =";INT(R2);"OHMS"
420 PRINT : PRINT 
430 INPUT "RUN AGAIN (y/n)";A$
440 IF A$="Y" OR A$="y" THEN PRINT CHR$(26) : GOTO 40
450 END
--\/\--o--/\/--o
150 PRINT TAB(40);"|  R2   |   R2  |
160 PRINT TAB(40);"|      ---      |
170 PRINT TAB(40);"|   C2 --