1 REM Corrected by Jim Woolley, FOG Disk Librarian, 8/82
1000 '                       SAVED AT DEPREC  01/04/82  1.0  TLB
1010 '               DEPRECIATION COMPUTATION PROGRAM
1020 ' ******************** DATA INITIALIZATION *******************
1030 X$="*********************************************************"
1040 PRINT "ENTER THE INITIAL COST OF THE ASSETS";
1050 INPUT C
1060 PRINT "ENTER THE LIFE OF THE ASSET (IN YEARS)";
1070 INPUT L
1080 DIM D(L),T$(3),D1(L+1)
1090 T$(1)="STRAIGHT-LINE DEPRECIATION"
1100 T$(2)="SUM-OF-THE-YEARS-DIGITS"
1110 T$(3)="DOUBLE-DECLINING BALANCE"
1120 PRINT "ENTER THE SALVAGE VALUE";
1130 INPUT S
1140 PRINT
1150 PRINT "THE FOLLOWING ALTERNATIVE DEPRECIATION METHODS ARE AVAILABLE"
1160 PRINT
1170 PRINT "1...STRAIGHT-LINE"
1180 PRINT "2...SUM-OF-THE-YEARS-DIGITS"
1190 PRINT "3...DOUBLE-DECLINING BALANCE"
1200 PRINT "4...ALL OF THE ABOVE"
1210 PRINT
1220 PRINT "ENTER THE NUMBER OF THE METHOD TO USE (4 FOR ALL)";
1230 O=0
1240 INPUT O
1250 PRINT
1260 IF O=0 THEN 1350
1270 IF O=1 THEN GOSUB 1430       'STRAIGHT-LINE
1280 IF O=2 THEN GOSUB 1550       'SUM OF THE YEARS DIGITS
1290 IF O=3 THEN GOSUB 1710       'DOUBLE-DECLINING
1300 IF O>4 THEN 1220
1305 IF O<4 THEN 1370
1310 GOSUB 1430                   'STRAIGHT-LINE
1320 GOSUB 1550                   'SUM OF THE YEARS DIGITS
1330 GOSUB 1710                   'DOUBLE-DECLINING
1340 ' ************************************************************
1350 '                  PROGRAM TERMINATION POINT
1360 ' ************************************************************
1370 PRINT
1380 PRINT
1390 PRINT "PROCESSING COMPLETE"
1400 PRINT
1410 STOP
1420 ' ************************************************************
1430 '                  STRAIGHT-LINE DEPRECIATION
1440 ' ************************************************************
1450 D0=C-S
1460 D1(1)=C
1470 FOR I=1 TO L
1480   D(I)=D0/L
1490   D1(I+1)=D1(I)-D(I)
1500 NEXT I
1510 K=1
1520 GOSUB 1840                   'PRINT RESULTS
1530 RETURN
1540 ' ************************************************************
1550 '                   SUM-OF-THE-YEARS-DIGITS
1560 ' ************************************************************
1570 D1(1)=C
1580 D0=C-S
1590 FOR I=1 TO L
1600   N=N+1
1610 NEXT I
1620 FOR I=1 TO L
1630   F=(L+1-I)/N
1640   D(I)=D0*F
1650   D1(I+1)=D1(I)-D(I)
1660 NEXT I
1670 K=2
1680 GOSUB 1840                   'PRINT RESULTS
1690 RETURN
1700 ' ************************************************************
1710 '                   DOUBLE-DECLINING BALANCE
1720 ' ************************************************************
1730 D1(1)=C
1740 PRINT "ENTER THE FACTOR TO BE APPLIED TO S-L RATE  I.E. 1.5";
1750 INPUT F
1760 FOR I=1 TO L
1770   D(I)=(D1(I)/(L))*F
1780   D1(I+1)=D1(I)-D(I)
1790 NEXT I
1800 K=3
1810 GOSUB 1840                   'PRINT RESULTS
1820 RETURN
1830 ' ************************************************************
1840 '                        PRINT OF RESULTS
1850 ' ************************************************************
1860 PRINT X$
1870 PRINT
1880 PRINT T$(K)
1890 PRINT
1900 PRINT "INITIAL VALUE ";C
1910 PRINT
1920 PRINT TAB(10);"DEPREC";TAB(20);"REM VALUE"
1930 PRINT
1940 FOR I=1 TO L
1950 PRINT "YEAR";I;TAB(10);D(I);TAB(20);D1(I+1)
1960 NEXT I
1970 PRINT
1980 PRINT "SALVAGE VALUE =";D1(I)
1990 PRINT X$
2000 PRINT
2010 RETURN
10);D(I);TAB(20)