1 REM   Performance Evaluation and Review Technique
2 REM	Developed by Steven M. Zimmerman,Ph.D. & Leo M. Conrad 1980
3 REM	"Byte" Publications Inc, May 1982	page 465
4 REM	This program was adapted from an article that appeared in BYTE by
5 REM	Roger De Haven.  The program was writen in TRS-80 BASIC, but was trans-
6 REM	lated to run using Microsoft BASIC.  Unlike the TRS-80 version, This 
7 REM	program has no provision for use with tape recorder interface for data
8 REM	input/output.  See the artical for complete explianation of the program
10 CLEAR 1000:CLOSE:REM "PERT"
20 PRINT "PERT/Criticlal Path Scheduling Program"
50 PRINT : PRINT "*** Note Begining Events Will Be Sorted into Numeric Order *"
51 INPUT "Dimensions for Activities";D% :PRINT
60 DIM A$(D%,2),A(D%,11),SV(11)
70 PRINT "Input Menue"
80 PRINT "	K	Keyboard"
90 PRINT "	D	Disk"
100 PRINT "	R	Read Statement"
130 INPUT "Selection";IO$
140 IF IO$<>"K" THEN 330
150 INPUT "Number of Activities";M% :EE=0
160 PRINT "This is going to be work you must input up to ";M%;" activities."
170 FOR I=1 TO M%
180 INPUT "Activity Code ";A$(I,1)
190 INPUT "Description, Begining event number, End event number, Most optimistic time, Most likely time and Most pessimistic time ";A$(I,2),A(I,1),A(I,2),A(I,3),A(I,4),A(I,5)
200 NEXT I
210 GOTO 480
330 IF IO$<>"D" THEN 420
340 LINE INPUT "Name of disk:file ";B$ :REM disk input
350 OPEN "I",1,B$
360 INPUT #1,M%,EE
370 FOR I=1 TO M%
380 INPUT #1,A$(I,1),A$(I,2),A(I,1),A(I,2),A(I,3),A(I,4),A(I,5)
390 NEXT I
400 CLOSE 1
410 GOTO 480
420 IF IO$<>"R" THEN 70
430 READ M%,EE
440 FOR I=1 TO M%: REM read input
450 READ A$(I,1),A$(I,2),A(I,1),A(I,2),A(I,3),A(I,4),A(I,5)
460 IF A$(I,1)="END" THEN 480
470 NEXT I
480 REM Prints input data for verification.
490 M=M%:TP=0:FOR I=1 TO M:IF A(I,2)>TP THEN TP=A(I,2)
495 NEXT:EE=TP
500 FOR I=1 TO M-1
510 FOR J=I+1 TO M
520 IF A(I,1)<=A(J,1) THEN 550
530 FOR K=1 TO 11:SV(K)=A(I,K):A(I,K)=A(J,K):A(J,K)=SV(K):NEXT K
540 FOR K=1 TO 2:SV$(K)=A$(I,K):A$(I,K)=A$(J,K):A$(J,K)=SV$(K):NEXT K
550 NEXT J,I
560 XX=5:PRINT "Verification of Input"
570 Z1$="Code Description Expected Early    Early    Last     Last     Slack"
580 Z2$="                 Time     Start    Fin      Start    Fin      Time"
590 Z3$="Code Description Begin  End   Optimist Likely  Pessi"
600 Z4$="                 Event  Event Time     Time     Time"
610 PRINT "No ";Z3$
620 PRINT "   ";Z4$
630 K=0
640 C4$="### "
650 FOR I=1 TO M%
660 PRINT USING C4$;I;
670 C1$=" ####"
680 C3$=" ####.## "
690 PRINT A$(I,1);TAB(9);A$(I,2);TAB(20);
700 FOR J=1 TO 2
710 PRINT USING C1$;A(I,J);:NEXT J
720 FOR J=3 TO 5
730 PRINT USING C3$;A(I,J);:NEXT J
740 K=K+1:IF K>=13 THEN PRINT:INPUT "Enter to page";DU$:K=0
750 PRINT:NEXT I
760 INPUT "-2 to add  -1 to continue or number to change";L: IF L=-1 THEN 810
770 IF L<>-2 THEN 790
780 L=M%+1:M%=L:N%=N%+1
790 INPUT "Input code, description, begining event number, end event number,most optimistic time, most likely time, and the most pessimistic time";A$(L,1),A$(L,2),A(L,1),A(L,2),A(L,3),A(L,4),A(L,5)
800 GOTO 480
810 INPUT "Hard copy of input data (Y/N)";P$
820 IF P$<>"Y" THEN 960
830 INPUT "Title";T$:LPRINT "Title:  ";T$
840 INPUT "Date";T$:LPRINT "Date:  ";T$
850 LPRINT "No ";Z3$
860 LPRINT "   ";Z4$
870 FOR I=1 TO M%
880 LPRINT USING C4$;I;
890 LPRINT A$(I,1);TAB(9);A$(I,2);TAB(20);
900 FOR J=1 TO 2
910 LPRINT USING C1$;A(I,J);:NEXT J
920 FOR J=3 TO 5
930 LPRINT USING C3$;A(I,J);:NEXT J
940 LPRINT " "
950 NEXT I
960 REM Now the work begins  begining event is 1 early start =0 forward pass
970 FOR I=1 TO M%
980 A(I,6)=(A(I,3)+4*A(I,4)+A(I,5))/6
990 IF A(I,1)=1 THEN A(I,7)=0:A(I,8)=A(I,6):GOTO 1070
1000 MAX=0!
1010 FOR J=1 TO M%
1020 IF A(J,2)<>A(I,1) THEN 1050
1030 IF A(J,8)>MAX THEN MAX=A(J,8)
1040 A(I,7)=MAX
1050 NEXT J
1060 A(I,8)=A(I,7)+A(I,6)
1070 NEXT I
1080 REM Backwards pass
1090 XM=0!
1100 FOR I=M% TO 1 STEP -1
1110 IF A(I,2)<>EE THEN 1130
1120 IF XM<A(I,8) THEN XM=A(I,8)
1130 NEXT I
1140 FOR I=M% TO 1 STEP -1
1150 IF A(I,2)=EE THEN A(I,10)=XM:GOTO 1220
1160 MIM=99999!
1170 FOR J=M% TO 1 STEP -1
1180 IF A(I,2)<>A(J,1) THEN 1210
1190 IF A(J,9)<MIM THEN MIM=A(J,9)
1200 A(I,10)=MIM
1210 NEXT J
1220 A(I,9)=A(I,10)-A(I,6)
1230 NEXT I
1240 REM Slack variable calculations
1250 FOR I=1 TO M%
1260 A(I,11)=A(I,10)-A(I,8)
1270 NEXT I
1280 K=0:REM Print output
1290 PRINT "Code description Expected Early  Early  Last  Last  Slack"
1300 PRINT "                 Time     Start  Fin    Start Fin   time"
1310 C5$=" ###.##"
1320 FOR I=1 TO M%
1330 PRINT A$(I,1);" ";A$(I,2);TAB(18);
1340 FOR J=6 TO 11
1350 PRINT USING C5$;A(I,J);:NEXT J
1360 PRINT :K=K+1:IF K=13 THEN INPUT "Enter to page";DU$:K=0
1370 NEXT I
1380 INPUT "Hard copy of results (Y/N)";P$:IF P$<>"Y" THEN 1450
1390 LPRINT " ":LPRINT Z1$:LPRINT Z2$
1400 FOR I=1 TO M%
1410 LPRINT A$(I,1);A$(I,2);TAB(18);
1420 FOR J=6 TO 11
1430 LPRINT USING C3$;A(I,J);:NEXT J
1440 LPRINT " ":NEXT I
1450 PRINT "OUTPUT MENUE"
1460 PRINT "     C      Critical Path and Time"
1470 PRINT "     D      Disk"
1480 PRINT "     E      End"
1510 INPUT "			Selection";OP$:IF OP$="R" THEN 480
1520 IF OP$<>"C" THEN 1690
1530 REM Identification of Critical Path and Costs
1540 CO=0:PATH$=" ":SI=0
1550 FOR I=1 TO M%:IF A(I,11)>.00001 THEN 1570:REM Note, >0 should work but .00001 used
1560 CO=CO+A(I,6):PATH$=PATH$+" "+A$(I,1):SI=SI+((A(I,3)-A(I,5))/6)^2
1570 NEXT I:C6$="###,###,###.##":SI=SQR(SI)
1580 CLOSE:PRINT "Critical Path":PRINT PATH$:PRINT
1590 PRINT "Time of Critical Path":PRINT USING C6$;CO:INPUT "Scheduled Project Time (use same time units as data)";ST:Z=(ST-CO)/SI:XX=0
1600 BB$="Probability of being completed on time":IF Z<0 THEN 1640
1610 A=.436184:B=-.120168:C=.937298:D=(2.7182818#^(-Z^2/2))*(2*3.1415926#)^(-.5):E=(1+.3326*Z)^(-1):P=1!-D*(A*E+B*E^2+C*E^3):IF XX>0 THEN 1630:REM Taylor Series
1620 PRINT "Z= ";Z,BB$;P:GOTO 1650
1630 PRINT "Z= ";-Z,BB$;1-P:GOTO 1650
1640 XX=99:Z=-Z:GOTO 1610
1650 INPUT "Hard copy (Y/N)";P$:IF P$<>"Y" THEN 1450
1660 LPRINT " ":LPRINT "Critical Path":LPRINT PATH$:LPRINT " ":LPRINT "Schedule Project time is ";ST
1670 LPRINT "Time of Critical Path":LPRINT USING C6$;CO:IF XX=0 THEN LPRINT "Z= ";Z,BB$;P:GOTO 1450
1680 LPRINT "Z= ";-Z,BB$;1-P:GOTO 1450
1690 IF OP$="E" THEN END
1700 IF OP$<>"D" THEN PRINT "Please enter again":GOTO 1450
1710 LINE INPUT "Name of disk:file?";X$:OPEN "O",1,X$
1720 PRINT #1,M%,EE
1730 FOR I=1 TO M%:PRINT #1, CHR$(34);A$(I,1);CHR$(34);",";CHR$(34);A$(I,2);CHR$(34);A(I,1);A(I,2);A(I,3);A(I,4);A(I,5):NEXT I
1740 CLOSE 1:GOTO 1450
1800 REM Put data here - first # activities, then ending event number, then code, description, beginnigh event, ending event, opt. time, pess.time for each activity.
1810 DATA 18,9
1820 DATA A,Acct. Papers,1,2,1,2,3
1830 DATA Z,Permits,2,7,4,5,8
1840 DATA B,Shop Bankers,1,3,2,4,6
1850 DATA C,Shop Real Est.,1,4,2,13,17
1860 DATA D,Market Study,2,3,2,4,5
1870 DATA G,Contractor,2,5,1.4,2.2,6.7
1880 DATA F,Insurance,2,6,.4,1.3,1.5
1890 DATA H,Art. Plans,3,5,2,4,6
1900 DATA E,Cost Study,3,4,3,4,5
1910 DATA I,Land,4,5,8,11,13
1920 DATA J,Material,5,6,2,3,4
1930 DATA K,Plans,5,7,2,5,12
1940 DATA L,Survey,5,8,1,2,4
1950 DATA M,Buy Mat #1,5,8,2,3,4
1960 DATA O,Buy Mat #2,6,9,1,2,5
1970 DATA N,Layout,7,8,9,11,12
1980 DATA P,Foundation,8,9,1,3,6
1990 DATA Q,Hire Crew 2,7,9,1,2,3
A O,Buy Mat #2,6,9,1,2,5
1970 DATA N,Layout,7,8,9,11,12
1980 DA