comment
**********************************************************************

This program strips the line feeds from a file input at program
request, creating a new file on the same disk with the type .UNX.

The program may be useful to those who wish to create files they
can pip to UNIX without picking up a lot of air in the process.

**********************************************************************
end
	procedure sound_bell
		print chr(7);
	end
	function get_string(max_length=integer)=string
		var s_char=char
		var s_txt=string
		s_txt=""
		echo off
		repeat
			begin
			input3 s_char
			if len(s_txt)<max_length and s_char>1FH and s_char<>7FH then
				begin
				if s_char>60H then s_char=s_char-20H
				print s_char;
				s_txt=s_txt+s_char
				end
			else
			if (s_char=08H or s_char=7FH) and len(s_txt)<>0 then
				begin
				s_txt=left$(s_txt,len(s_txt)-1)
				print chr(08H);chr(20H);chr(08H);
				end
			else
			if s_char<>0DH and s_char<>09H then sound_bell	
			end
		until s_char=0DH or s_char=09H
		echo on
	end=s_txt
rem
function root_name( file_name = string ) = string
	var period = integer
	var root = string
	period = instr( 1, file_name, '.' )
	if period = 0 then root = file_name + '.'
	else root = left$( file_name, period )
end = root
rem
rem
	var a,b=string
	var cr, lf = char
	cr = 0DH
	lf = 0AH
	print cr; lf; "Enter the complete unambiguous name of the file"
	print "you wish stripped of line feeds (e.g. A:MYDOC.FIL): ";
	a = get_string( 14 )
	b = root_name( a ) + "UNX"
	print cr;lf;lf, a; " -------> "; b; "        OK? ";
	var response = char
	input3 response
	if (response <> 'y') and (response <> 'Y') then stop
	print lf
	print "             ***converting***"

	files s(64),s(64)
	open #0; a
	create b
	open #1; b
	var file_char = char
	repeat
		begin
			read #0; file_char
			if file_char <> 1AH then print file_char;
			if file_char <> lf then write #1; file_char
		end
	until file_char = 1AH
	close #0
	close #1
	sound_bell
	print
	print "          ***File Conversion Done***"
	stop
nction root_name( file_name = string ) = string
	var period = i