10 REM **** 'INTERMOD' Intermod/Harmonic Table Program ****
20 REM **** "Microwave Journal", May 85, p. 297
30 REM **** Frequency units changed from GHz to MHz - R. S. Stein - 7/10/85
80 PRINT CHR$(26)
100 PRINT "'INTERMOD' - MIXER INTERMOD TABLE VER. 1 REV. B - M. GOLDFARB - AUG 1984"
101 PRINT STRING$(72,"=")
102 PRINT
105 INPUT "OUTPUT TO PRINTER (y/n) ";Y$
107 IF Y$="Y" OR Y$="y" THEN Y$="Y" ELSE Y$="N"
108 PRINT 
110 INPUT "L.O. FREQUENCY RANGE IN MHz (Low, High) ";L1,L2
120 INPUT "RF FREQUENCY RANGE IN MHz (Low, High) ";R1,R2
130 INPUT "OUTPUT FREQUENCY IN MHz (Low, High) ";I1,I2
140 PRINT 
141 PRINT "Max. Product Order = n + m, where"
142 PRINT "   (m * RF) + (n * L.O.) is the sum product, and"
143 PRINT "   (m * RF) - (n * L.O.) is the difference product"
144 PRINT 
150 INPUT "MAX. PRODUCT ORDER (n+m) ";Q
160 L=(L1+L2)/2	'L.O. center freq
170 R=(R1+R2)/2	'RF center freq
180 B2=(R2-R1)/R*2
185 A1$="Order  RF   L.O.      Low Product         High Product      Product in"
190 B$ ="(n+m)  (m)  (n)         (mR-nL)             (mR+nL)         output band"
195 C$=" ##    ##   ##   #####.# to #####.#    #####.# to #####.#       \    \"
200 D$="-----------------------------------------------------------------------"
210 PRINT CHR$(26)
220 PRINT "************ Mixer Intermodulation/Harmonic Product Table ************"
225 PRINT 
226 IF Y$="N" THEN 235
227 LPRINT "************ Mixer Intermodulation/Harmonic Product Table ************"
229 LPRINT 
230 LPRINT "L.O. Frequency Range  :  ";L1;"MHz to";L2;"MHz"
231 LPRINT "RF Frequency Range    :  ";R1;"MHz to";R2;"MHz"
232 LPRINT "Output Frequency Range:  ";I1;"MHz to";I2;"MHz"
233 LPRINT 
234 LPRINT A1$ : LPRINT B$ : LPRINT D$
235 PRINT A1$ : PRINT B$ : PRINT D$
240 I=13	'Page counter
250 M=0	'Initialize RF counter
260 N=Q	'Start loop with n = max. order
320 GOSUB 1000	'Calculate products for given order Q
330 A$="No"	'Test for spur in output band
340 IF U1>=I1 AND U1<=I2 THEN A$="Yes"
350 IF U2>=I1 AND U2<=I2 THEN A$="Yes"
360 IF U1>=I1 AND U2<=I2 THEN A$="Yes"
362 IF U1<=I1 AND U2>=I2 THEN A$="Yes"
364 IF M=1 AND N=1 THEN A$="Output"
366 IF N+M=4 THEN PRINT : I=I-1
367 IF N+M=4 AND Y$="Y" THEN LPRINT 
370 IF I=0 THEN PRINT : INPUT "<CR> to continue ",X$
371 IF I>0 THEN 380
372 PRINT CHR$(26)
374 PRINT A1$ : PRINT B$ : PRINT D$
376 PRINT : I=13
377 IF Y$="Y" THEN LPRINT 
380 PRINT USING C$;N+M;M;N;U1;U2;V1;V2;A$
382 IF Y$="Y" THEN LPRINT USING C$;N+M;M;N;U1;U2;V1;V2;A$
385 I=I-1
390 N=N-1
395 IF M=0 AND N=0 THEN 410
400 IF N>=0 THEN 320
410 M=M+1 : N=Q-M
415 PRINT 
420 IF M<=Q THEN 320
430 PRINT 
437 INPUT "New Table (N) or Quit (Q) ";X$
440 IF X$="N" OR X$="n" THEN 80
450 END
1000 REM ***** CALCSPUR Subroutine *****
1010 IF M*R>=N*L THEN X=1 ELSE X=0
1015 Y=0
1020 IF X=0 AND N*L1>M*R2 THEN Y=1
1030 IF X=1 AND M*R1>N*L2 THEN Y=1
1040 IF Y=0 THEN U1=0
1050 IF Y=1 AND X=0 THEN U1=N*L1-M*R2
1060 IF Y=1 AND X=1 THEN U1=M*R1-N*L2
1070 IF X=0 THEN U2=N*L2-M*R1 ELSE U2=M*R2-N*L1
1080 V1=M*R1+N*L1
1090 V2=M*R2+N*L2
1100 IF M=0 THEN U1=N*L1
1110 IF N=0 THEN U1=M*R1
1120 RETURN
M*R1 ELSE U2=M*R2-N*L1
1080 V1=M*R1+N*L1
1090 V2